


class Producer extends Thread {
  Port out ;

  public Producer (Port out) {
    this.out = out ;
  }

  public void run() {
    //while(true) {
    for(int i = 0 ; i < 100 ; i++) {
      out.sendInt(1) ;
    }
  }
}


class Consumer extends Thread {
  Port prev, next, in ;
  int id ;

  public Consumer(Port prev, Port next, int id, Port in) {
    this.prev = prev ;
    this.next = next ;
    this.in   = in  ;

    this.id = id ;
  }

  public Consumer(Port prev, Port next, int id) {
    this.prev = prev ;
    this.next = next ;
    this.in   = new Port() ;

    this.id = id ;
  }

  public void run() {
    if(id == 0 ) {
      System.out.println("Consumer " + id + " got " + in.recvInt()) ;
      prev.sendChan(in) ;
    }
    while(true) {
      next.recvChan(in) ;
      System.out.println("Consumer " + id + " got " + in.recvInt()) ;
      prev.sendChan(in) ;
    }
  }
}


public class Eg5a {
  static final int m = 4 ;

  public static void main(String args[]) {

    // Create output channel

    Port R = new Port() ;
    Port S = new Port() ;

    Port.channel(R, S) ;

    // Fork a producer

    (new Producer(R)).start() ;

    // Create a ring of channels

    Port T [] = new Port [m] ;
    Port U [] = new Port [m] ;

    for(int i = 0 ; i < m ; i++) {
      T [i] = new Port() ;
      U [i] = new Port() ;
    }

    for(int i = 0 ; i < m ; i++)
      Port.channel(U [i], T [(i + 1) % m]) ;

    // Fork a ring of consumers

    (new Consumer(T [0], U [0], 0, S)).start() ;
    for(int i = 1 ; i < m ; i++)
      (new Consumer(T [i], U [i], i)).start() ;

  }
}


